<template>
	<div class="ml-2 mr-2 search-btn">
		<label for="default-search"
			class="mb-2 text-sm font-medium text-gray-900 sr-only dark:text-gray-300">Search</label>
		<div class="relative">
			<div class="flex absolute inset-y-0 left-0 items-center pl-3 pointer-events-none">
				<svg aria-hidden="true" class="w-5 h-5 text-gray-500 dark:text-gray-400" fill="none"
					stroke="currentColor" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
					<path stroke-linecap="round" stroke-linejoin="round" stroke-width="2"
						d="M21 21l-6-6m2-5a7 7 0 11-14 0 7 7 0 0114 0z"></path>
				</svg>
			</div>
			<input type="search" id="user-search" @change="filteredList($event.target.value)"
				class="block p-4 pl-10 w-full text-sm text-gray-900 rounded-lg border border-gray-300 focus:ring-blue-500 focus:border-blue-500 dark:bg-gray-900 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500"
				placeholder="Search username">
		</div>
		<span
			class="bg-gray-100 text-gray-800 text-sm font-medium mr-2 px-2.5 py-0.5 rounded dark:bg-gray-700 dark:text-gray-300">Total:
			{{ count }}</span>
	</div>
	<div class="grid grid-cols-1 gap-3 sm:grid-cols-2 md:grid-cols-3">
		<div v-for="user in listUser" :key="user.login" @click="getUser(user.login)"
			class="flex flex-col py-4 px-6 shadow-md bg-gray-900 hover:bg-lime-700 h-[320px]">
			<img :src="user.avatar_url" alt="" class="w-full h-48 object-cover">
			<h4 class="mt-4 text-fuchsia-50 text-lg font-bold">{{ user.login }}</h4>
			<div class="overflow-hidden flex-1">
				<span
					class="bg-blue-100 text-blue-800 text-sm font-medium mr-2 px-2.5 py-0.5 rounded dark:bg-blue-200 dark:text-blue-800">
					{{ user.site_admin ? "Owner" : "Staff" }}
				</span>
			</div>
		</div>
	</div>
	<div id="userModal" v-if="Object.keys(this.currentUser).length > 0" class="fixed animated fadeIn">
		<!-- Main modal -->
		<div
			class="overflow-y-auto overflow-x-hidden fixed top-10 right-30 left-30 z-50 md:inset-0 h-modal h-full flex justify-center bg-gray-600 bg-opacity-75">
			<div class="align-center relative p-4 w-fit max-w-2xl h-full md:h-auto">
				<!-- Modal content -->
				<div class="relative bg-white rounded-lg shadow dark:bg-gray-700">
					<!-- Modal header -->
					<div class="flex justify-between items-start p-4 rounded-t border-b dark:border-gray-600">
						<h3 class="text-xl font-semibold text-gray-900 dark:text-white">
							Update User
						</h3>
						<button type="button" @click="closeModal()"
							class="text-gray-400 bg-transparent hover:bg-gray-200 hover:text-gray-900 rounded-lg text-sm p-1.5 ml-auto inline-flex items-center dark:hover:bg-gray-600 dark:hover:text-white">
							<svg aria-hidden="true" class="w-5 h-5" fill="currentColor" viewBox="0 0 20 20"
								xmlns="http://www.w3.org/2000/svg">
								<path fill-rule="evenodd"
									d="M4.293 4.293a1 1 0 011.414 0L10 8.586l4.293-4.293a1 1 0 111.414 1.414L11.414 10l4.293 4.293a1 1 0 01-1.414 1.414L10 11.414l-4.293 4.293a1 1 0 01-1.414-1.414L8.586 10 4.293 5.707a1 1 0 010-1.414z"
									clip-rule="evenodd"></path>
							</svg>
							<span class="sr-only">Close modal</span>
						</button>
					</div>
					<!-- Modal body -->
					<div
						class="max-w-sm bg-white rounded-lg border border-gray-200 shadow-md dark:bg-gray-800 dark:border-gray-700">
						<a href="#">
							<img class="rounded-t-lg w-full" :src="currentUser.avatar_url" alt="" />
						</a>
						<div class="p-5">
							<a href="#">
								<h5 @click="editToggle" :class="inputHidden ? '' : 'hidden'"
									class="mb-2 text-2xl font-bold tracking-tight text-gray-900 dark:text-white">
									{{ currentUser.name ?? 'Name is empty' }}</h5>
								<input id="username"
									class="mb-2 border border-gray-300 text-gray-900 text-sm rounded-lg focus:ring-blue-500 focus:border-blue-500 block w-full p-2.5 dark:bg-gray-700 dark:border-gray-600 dark:text-white dark:placeholder-gray-400 dark:focus:ring-blue-500 dark:focus:border-blue-500"
									@focusout="editToggle" v-model="currentUser.name"
									:class="inputHidden ? 'hidden' : ''" type="text" />
							</a>
							<p class="mb-3 font-normal text-gray-700 dark:text-gray-400 flex">
							<div
								class="overflow-hidden relative w-10 h-10 bg-gray-100 rounded-full dark:bg-gray-600 mr-3">
								<svg class="absolute -left-1 w-12 h-12 text-gray-400" fill="currentColor"
									viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg">
									<path fill-rule="evenodd" d="M10 9a3 3 0 100-6 3 3 0 000 6zm-7 9a7 7 0 1114 0H3z"
										clip-rule="evenodd"></path>
								</svg>
							</div>
							<span class="self-center">
								{{ currentUser.login }}
							</span>
							<span
								class="bg-blue-100 text-blue-800 text-sm font-medium mr-2 px-2.5 py-0.5 rounded dark:bg-blue-200 dark:text-blue-800 ml-1 self-center">
								{{ currentUser.site_admin ? "Owner" : "Staff" }}
							</span>
							</p>
							<p class="mb-3 font-normal text-gray-700 dark:text-gray-400 flex">
								<svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24"
									stroke-width="1.5" stroke="currentColor" class="w-6 h-6 mr-2">
									<path stroke-linecap="round" stroke-linejoin="round"
										d="M12 7.5h1.5m-1.5 3h1.5m-7.5 3h7.5m-7.5 3h7.5m3-9h3.375c.621 0 1.125.504 1.125 1.125V18a2.25 2.25 0 01-2.25 2.25M16.5 7.5V18a2.25 2.25 0 002.25 2.25M16.5 7.5V4.875c0-.621-.504-1.125-1.125-1.125H4.125C3.504 3.75 3 4.254 3 4.875V18a2.25 2.25 0 002.25 2.25h13.5M6 7.5h3v3H6v-3z" />
								</svg>

								<span> {{ currentUser.bio }} </span>
							</p>
							<p class="mb-3 font-normal text-gray-700 dark:text-gray-400 flex">
								<svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24"
									stroke-width="1.5" stroke="currentColor" class="w-6 h-6 mr-2">
									<path stroke-linecap="round" stroke-linejoin="round"
										d="M15 10.5a3 3 0 11-6 0 3 3 0 016 0z" />
									<path stroke-linecap="round" stroke-linejoin="round"
										d="M19.5 10.5c0 7.142-7.5 11.25-7.5 11.25S4.5 17.642 4.5 10.5a7.5 7.5 0 1115 0z" />
								</svg>

								<span class="self-centers">
									{{ currentUser.location }}
								</span>
							</p>
							<p class="mb-3 font-normal text-gray-700 dark:text-gray-400 flex">
								<svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24"
									stroke-width="1.5" stroke="currentColor" class="w-6 h-6 mr-2">
									<path stroke-linecap="round" stroke-linejoin="round"
										d="M13.19 8.688a4.5 4.5 0 011.242 7.244l-4.5 4.5a4.5 4.5 0 01-6.364-6.364l1.757-1.757m13.35-.622l1.757-1.757a4.5 4.5 0 00-6.364-6.364l-4.5 4.5a4.5 4.5 0 001.242 7.244" />
								</svg>

								<span>
									{{ currentUser.blog }}
								</span>
							</p>
						</div>
					</div>
					<!-- Modal footer -->
					<div
						class="flex justify-center p-6 space-x-2 rounded-b border-t border-gray-200 dark:border-gray-600">
						<button type="button" @click="saveUser"
							class="text-white bg-blue-700 hover:bg-blue-800 focus:ring-4 focus:outline-none focus:ring-blue-300 font-medium rounded-lg text-sm px-5 py-2.5 text-center dark:bg-blue-600 dark:hover:bg-blue-700 dark:focus:ring-blue-800">Save</button>
						<button type="button" @click="closeModal()"
							class="text-gray-500 bg-white hover:bg-gray-100 focus:ring-4 focus:outline-none focus:ring-blue-300 rounded-lg border border-gray-200 text-sm font-medium px-5 py-2.5 hover:text-gray-900 focus:z-10 dark:bg-gray-700 dark:text-gray-300 dark:border-gray-500 dark:hover:text-white dark:hover:bg-gray-600 dark:focus:ring-gray-600">Close</button>
					</div>
				</div>
			</div>
		</div>
	</div>

</template>

<script>
export default {
	data() {
		return {
			listUser: {},
			showModal: false,
			currentUser: {},
			inputHidden: true,
			count: 0
		}
	},
	created() {
		this.filteredList()
	},
	methods: {
		async filteredList(searchValue = '') {
			this.listUser = this.$store.state.user.list;
			if (!this.listUser.length) {
				await this.$store.dispatch('user/getListUser')
				this.listUser = this.$store.state.user.list;
			}
			if (searchValue !== '') {
				this.listUser = this.listUser.filter((user) =>
					user.login.toLowerCase().includes(searchValue.toLowerCase())
				);
			}
			this.count = this.listUser.length;
		},
		async getUser(username) {
			this.currentUser = await this.$store.dispatch('user/getUser', username)
		},
		closeModal() {
			this.currentUser = {}
		},
		editToggle() {
			this.inputHidden = !this.inputHidden
		},
		async saveUser() {
			let update = await this.$store.dispatch('user/updateUser', this.currentUser)
			if (update.status === 'Successful') {
				this.listUser = this.listUser.map((u) => {
					if (u.login === this.currentUser.login) {
						return this.currentUser;
					}
					return u;
				});
				this.$toast.success(update.message);
			} else {
				this.$toast.error(update.message);
			}
			this.closeModal()
		}
	}
}

</script>

<style lang="scss" scoped>

</style>